unit snobed;

{$mode objfpc}{$H+}
//snobed- converted from delphi to lazarus
//mikeparr@live.com
//use the source as you wish, but you cannot sell it
interface

uses
  Classes,editsno, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Process, Dialogs, LCLType,
  ExtCtrls, StdCtrls, Menus, PairSplitter, SynMemo, SynHighlighterJava, lclintf;

 type

  { TTMainForm }

  TTMainForm = class(TForm)
  FragmentsButton: TButton;
  ClearCLA: TMenuItem;
  MenuItem5: TMenuItem;
  newUnitpp: TButton;
  XrefSpellButton: TButton;
  ChooseRedInterp: TMenuItem;
  helpOnGogoMenu: TMenuItem;
  newGoFileClick: TMenuItem;
    ChooseInterp: TMenuItem;
    ShowChosenInterp: TMenuItem;
    MenuItem4: TMenuItem;
    helpOnRideMenu: TMenuItem;
    selectAllMenu: TMenuItem;
    showCommLineArgsMenu: TMenuItem;
    setCommandLineArgsClick: TMenuItem;
    runButton: TButton;
    errorListBox: TListBox;
    FindDialog1: TFindDialog;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    exitMenuItem: TMenuItem;
    MenuItem2: TMenuItem;
    cutMenuItem: TMenuItem;
    copyMenuItem: TMenuItem;
    findMenuItem: TMenuItem;
    MenuItem3: TMenuItem;
    biggerTextmenuItem: TMenuItem;
    OpenDialogExe: TOpenDialog;
    smallerTextMenuItem: TMenuItem;
    ReplaceDialog1: TReplaceDialog;
    undoMenuItem: TMenuItem;
    replaceMenuItem: TMenuItem;
    pasteMenuItem: TMenuItem;
    saveAsMenuItem: TMenuItem;
    saveMenuItem: TMenuItem;
    OpenDialog: TOpenDialog;
    openMenuItem: TMenuItem;
    newFileClick: TMenuItem;
    PairSplitter1: TPairSplitter;
    PairSplitterSide1: TPairSplitterSide;
    PairSplitterSide2: TPairSplitterSide;
    Panel1: TPanel;
    Panel2: TPanel;
    editWin: TSynMemo;
    SaveDialog: TSaveDialog;
    SynJavaSyn1: TSynJavaSyn;
    procedure biggerTextmenuItemClick(Sender: TObject);
    procedure bracketsButtonClick(Sender: TObject);
    procedure ClearCLAClick(Sender: TObject);
    procedure closeMenuClick(Sender: TObject);
    procedure ChooseRedInterpClick(Sender: TObject);
    procedure FragmentsButtonClick(Sender: TObject);
    procedure MenuItem1Click(Sender: TObject);
    procedure MenuItem5Click(Sender: TObject);
    procedure newUnitppClick(Sender: TObject);
    procedure PairSplitterSide1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PairSplitterSide2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure redConsoleClick(Sender: TObject);
    procedure RunExeButtonClick(Sender: TObject);
    procedure ShowChosenInterpClick(Sender: TObject);
    procedure runButtonClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure helpOnRideMenuClick(Sender: TObject);
    procedure copyMenuItemClick(Sender: TObject);
    procedure cutMenuItemClick(Sender: TObject);
    procedure editWinChange(Sender: TObject);
    procedure exitMenuItemClick(Sender: TObject);
    procedure findMenuItemClick(Sender: TObject);
    procedure newFileClickClick(Sender: TObject);
    procedure openMenuItemClick(Sender: TObject);
    procedure pasteMenuItemClick(Sender: TObject);
    procedure replaceMenuItemClick(Sender: TObject);
    procedure saveAsMenuItemClick(Sender: TObject);
    procedure ReplaceDialog1Replace(Sender: TObject);
    procedure ReplaceDialog1Find(Sender: TObject);
    procedure FindDialog1Find(Sender: TObject);
    function SaveFileAs(nameToShow:string) : integer;
    function OKtoCloseCurrentDoc : boolean;
    procedure saveMenuItemClick(Sender: TObject);
    procedure selectAllMenuClick(Sender: TObject);
    procedure setCommandLineArgsClickClick(Sender: TObject);
    procedure showCommLineArgsMenuClick(Sender: TObject);
    procedure smallerTextMenuItemClick(Sender: TObject);
    procedure undoMenuItemClick(Sender: TObject);
    procedure  interpretApplic;
    procedure FormCreate(Sender: TObject);
    procedure doPrettyPrint;
    function  CrossRef:string;
    procedure XrefSpellButtonClick(Sender: TObject);

private      { private declarations }

commandLineArgs:string;
fileNameWithPath : string;         // e.g  c:\myfiles\fred.red
batFile:textfile;
snobolCompiler: string;
IDEDirectory:string;     // the working dir of the IDE-so it can find any helper files
initialUserDir:string;   // user's initial open/save dir
outFile:textfile;
inFile:textfile;
ppStatus: textfile;

// --- Save and Close
procedure SetFileName( fn : string );
procedure ClearEditWin;
procedure DoSaveFile;
function  ConfirmFileSave( fn, msg : string) : integer;
function SaveFile : integer;    //what is this?
function setupOK:boolean;
function ReplaceIn(SearchFor, ReplaceStr, Str : String): String;

public
    { public declarations }
end;
  //----------------------------------------------------------------------------

var        //global
  TMainForm: TTMainForm;

     //These 2 vars for search/replace dialogs
     fPos:integer;
     found:boolean;

     ifCount, fiCount, whileCount, wendCount: integer; //for indenter


const
 VERSION = '1-JAN-24';
   TAB = #09;
   CR  = #13;
   LF  = #10;
   CRLF = CR + LF;  //laz
   QU = '"';    //for eg dos file names qith spaces in them

   EOL = #10;  //linux
    STEP = 4;     //indent level
   NEWFILENAME = 'Untitled';
   APPNAME = 'Snobed';

   FILEOVERWRITEMSG = '%s already exists. OK to overwrite?';
   FILESAVEMSG = 'Save changes to %s?';


//---------------------------------------------------------------------------

implementation
{$R *.lfm}

procedure TTMainForm.SetFileName( fn : string );
begin
   fileNameWithPath := fn;
   Caption := Format('%s : [%s]', [APPNAME,ExtractFileName(fn)]);

end;

//------------------------------------------------------------------------------

procedure TTMainForm.ClearEditWin;
begin
  EditWin.Lines.Clear;
  EditWin.Modified := False;
  SetFileName('');
end;

//------------------------------------------------------------------------------

function TTMainForm.ConfirmFileSave( fn, msg : string ) : integer;
var
  savechoice : integer;

begin
    savechoice := MessageDlg(Format(FILESAVEMSG, [ExtractFileName(fn)]),
      mtConfirmation, mbYesNoCancel, 0);  //laz
    case savechoice of
      IDYES: result := IDYES;
      IDNO: result := IDNO;
      IDCANCEL: result := IDCANCEL;
      else result := 0;
    end;
end;

//-----------------------------------------------------------------------------
procedure TTMainForm.DoSaveFile;
begin
  if fileNameWithPath <>'' then begin
      EditWin.Lines.SaveToFile( fileNameWithPath);
      EditWin.Modified := False;
  end;
end;

//-----------------------------------------------------------------------------

function TTMainForm.SaveFile : integer;   //TResponse;
var
   saveit : integer;   //TResponse;
begin
  saveit := IDYES;
  if (ExtractFileName(fileNameWithPath) = NEWFILENAME)
   or (ExtractFileName(fileNameWithPath) = '')  //added by mike
  then  //OK?? what if dif folders?
    saveit := SaveFileAs ('')
  else
    DoSaveFile;
    result := saveit;
end;
//-------------------------------------------------------------------------------

{ The function searches for a substring 'SearchFor' in a string
  'Str' and replaces all found substrings by 'ReplaceStr'
  It is NOT used by the dialogs.  - they have their own replace }

function TTMainForm.ReplaceIn(SearchFor, ReplaceStr, Str : String): String;
var
  Dummy, st : String;
  i : integer;
begin
  { make a temp. copy of the Str }
  st := Str;
  { first position of the substring }
  i := Pos(SearchFor, St);
  Dummy := '';

  { search lasts while the specified substring is found }
  while i <> 0 do
  begin
    Dummy := Dummy + Copy(St, 0, i - 1) + ReplaceStr;
    st := copy(st, i + length(SearchFor), length(st)+1);
    i := Pos(SearchFor, St);
  end;

  { result: the substrings replaced by 'ReplaceStr' }
  result := Dummy + st;
end;

//-----------------------------------------------------------------------------

function TTMainForm.OKtoCloseCurrentDoc : boolean;
var
   docloseIt, dosaveIt : integer;     //laz clash - remamed these
begin
   if fileNamewithPath <>'' then  begin
      docloseIt := IDYES;
       dosaveIt := IDNO;
       if EditWin.Modified then
       case ConfirmFileSave( ExtractFileName(fileNameWithPath), FILESAVEMSG ) of   //laz
          IDYES: dosaveIt := SaveFile;
          IDNO, 0 : { do nothing } ;    //laz - ok?
          IDCANCEL: docloseIt := IDNO;
       end;
       if (docloseIt = IDYES) and (dosaveIt <> IDCANCEL) then
          result := true
       else
          result := false
   end
   else
       result:=true;

end;

//---------------------------------------------------------------------------

function TTMainForm.SaveFileAs(nameToShow:string): integer;
var
   saveit : integer;
   saveAnswer:boolean;
begin
  saveit := IDYES;     //laz
  //ved
  If nameToShow <> '' then
     SaveDialog.filename:=nameToShow;

 saveAnswer:= SaveDialog.Execute;
   if saveAnswer then
       begin

       if FileExists(SaveDialog.FileName) then
            saveit := ConfirmFileSave(SaveDialog.FileName, FILEOVERWRITEMSG); //laz

       if saveit = IDYES then     //laz
            begin
                SetFileName(SaveDialog.FileName);
                DoSaveFile;   // problem if user cancels while creating a new applic/applet
             end;
  end
  else saveit := IDCANCEL;  //laz
  result := saveit;
end;
//-----------------------------------------------------------------------------

function TTMainform.setupOK:boolean;       // 2 cases
begin
if fileNameWithPath ='' then begin
    showMessage('No saved program !');
    setupOK:=false;
    end
 else setupOK:=true;
end;

//----------------------------------------------------------------------------

procedure TTMainForm.saveMenuItemClick(Sender: TObject);
begin
  SaveFile;
end;
//-----------------------------------------------------------------------------

procedure TTMainForm.selectAllMenuClick(Sender: TObject);
begin
editwin.selectAll;
end;

//-----------------------------------------------------------------------------

procedure TTMainForm.setCommandLineArgsClickClick(Sender: TObject);
var clickedOK:boolean;
mess:string;
begin
mess:= 'Enter command-line , using MYFILE to stand for your source file name';
ClickedOK := InputQuery('Enter Command-Line, ', mess, commandLineArgs);
end;
//-----------------------------------------------------------------------------

procedure TTMainForm.showCommLineArgsMenuClick(Sender: TObject);
begin
if commandLineArgs='' then
    showmessage('Command line unset.')
else
    showmessage('Command line is:'+EOL+EOL+commandLineArgs);
end;

//------------------------------------------------------------------------------
procedure TTMainForm.openMenuItemClick(Sender: TObject);
begin
if  OKtoCloseCurrentDoc then
      if OpenDialog.Execute then

         begin  {ok to open... }
             ErrorListBox.clear;
             EditWin.Lines.LoadFromFile(OpenDialog.FileName);
             SetFileName(OpenDialog.FileName);  // sets FileName with path!
             EditWin.SetFocus;
             EditWin.Modified := True;      // new code
         end;
end;
//-----------------------------------------------------------------------------

//------------------ begin search/replace stuff ---DO NOT ALTER ---------------

//replacement for selLength prop - linux synedit doesnt have it - mike
procedure setSelLength(var textComponent:TSynMemo; newValue:integer);
begin
textComponent.SelEnd:=textComponent.SelStart+newValue ;
end;
//----------------------------------------------------------------------------

procedure TTMainForm.ReplaceDialog1Find(Sender: TObject);    //yes, IS used by Laz
var
  FindS: String;
  IPos, FLen, SLen: Integer; {Internpos, Lengde søkestreng, lengde memotekst}
  Res : integer;
begin
  {FPos is global}
  Found:= False;
  FLen := Length(ReplaceDialog1.FindText);
  SLen := Length(editWin.Text);
  FindS := ReplaceDialog1.FindText;

 //following 'if' added by mike
  if frMatchcase in ReplaceDialog1.Options then
     IPos := Pos(FindS, Copy(editWin.Text,FPos+1,SLen-FPos))
  else
     IPos := Pos(AnsiUpperCase(FindS),AnsiUpperCase( Copy(editWin.Text,FPos+1,SLen-FPos)));

  If IPos > 0 then begin
    FPos := FPos + IPos;
 //   Hoved.BringToFront;       {Edit control must have focus in } - what is this? mike
    editWin.SetFocus;
    Self.ActiveControl := editWin;
    editWin.SelStart:= FPos;  // removed -1;   mike   {Select the string found by POS}
    setSelLength(editWin, FLen);     //editWin.SelLength := FLen;
    Found := True;
    FPos:=FPos+FLen-1;   //mike - move just past end of found item
  end
  Else
  begin
    If not (ReplaceDialog1.Options*[frReplaceAll] = [frReplaceAll]) then
      Res := Application.MessageBox('Text was not found!', 'Replace',
      mb_OK + mb_ICONWARNING);
    FPos := 0;     //mike  nb user might cancel dialog, so setting here is not enough
  end;             //   - also do it before exec of dialog.

 end;
 //-----------------------------------------------------------------------------

procedure TTMainForm.ReplaceDialog1Replace(Sender: TObject);
var
    Res, replaceCount:integer;   //added by mike
    countInfo:string;
begin
  If Found = False then       {If no search for string took place}
  begin
    ReplaceDialog1Find(Sender); {Search for string, replace if found}
    If Length(editWin.SelText) > 0 then
        editWin.SelText :=  ReplaceDialog1.ReplaceText;
  end
  Else                          {If search ran, replace string}
  begin
    If Length(editWin.SelText) > 0 then
        editWin.SelText := ReplaceDialog1.ReplaceText;
  end;
  Found := False;
  setSelLength(editWin, 0);    //editWin.SelLength := 0;
  {Hvis Erstatt alle...}
  If (ReplaceDialog1.Options*[frReplaceAll] = [frReplaceAll]) then begin
      replaceCount:=0;
      Repeat
        ReplaceDialog1Find(Sender); {Search for string, replace if found}
        If Length(editWin.SelText) > 0 then begin
            editWin.SelText := ReplaceDialog1.ReplaceText;
            replaceCount:=replaceCount+1;
        end;                                   //laz, syn
     until Found = False;
      if replaceCount>0 then
         replaceCount:=replaceCount+1;   //the first 1, then loop for rest  - mike
      countInfo:=inttostr(replaceCount)+'  replacements made.';
      Res := Application.MessageBox(pchar(countInfo),
             'Replace', mb_OK + mb_ICONINFORMATION);

  end;
end;

//--------------------------------------------------------------------------------

procedure TTMainForm.FindDialog1Find(Sender: TObject);  //based on replaceD1find
var
  FindS: String;
  IPos, FLen, SLen: Integer; {Internpos, Lengde søkestreng, lengde memotekst}
  Res : integer;
begin
  {FPos is global}
  Found:= False;
  FLen := Length(findDialog1.FindText);
  SLen := Length(editWin.Text);
  FindS := findDialog1.FindText;

 //following 'if' added by mike
  if frMatchcase in findDialog1.Options then
     IPos := Pos(FindS, Copy(editWin.Text,FPos+1,SLen-FPos))
  else
     IPos := Pos(AnsiUpperCase(FindS),AnsiUpperCase( Copy(editWin.Text,FPos+1,SLen-FPos)));

  If IPos > 0 then begin
    FPos := FPos + IPos;
 //   Hoved.BringToFront;       {Edit control must have focus in }
    editWin.SetFocus;
    Self.ActiveControl := editWin;
    editWin.SelStart:= FPos;  // -1;   mike   {Select the string found by POS}
    setSelLength(editWin, FLen);     //editWin.SelLength := FLen;
    Found := True;
    FPos:=FPos+FLen-1;   //mike - move just past end of found item

  end
  Else
  begin
    Res := Application.MessageBox('Text was not found!',
           'Find',  mb_OK + mb_ICONWARNING);
    FPos := 0;     //mike  nb user might cancel dialog, so setting here is not enough
  end;             //   - also do it before exec of dialog.

end;

//-----------------------------end sarch/rep stuff -----------------------------




//----------------------------------------------------------------------------
procedure TTMainForm.saveAsMenuItemClick(Sender: TObject);
begin
 SaveFileAs('');
end;
//-----------------------------------------------------------------------------

procedure TTMainForm.interpretApplic;      // - Aprocess not used now

var cline, compilername,line , userFileFolder :string;
begin

//Assignfile(batFile,'comperrs.txt');
ErrorListBox.Clear;
userFileFolder:=ExtractFileDir(fileNameWithPath);
EditWin.Lines.SaveToFile(fileNameWithPath);
EditWin.modified:=false;
Assignfile(batFile, userFileFolder+ '\docomp.bat');

rewrite(batfile);
if commandLineArgs= '' then begin //simple run
    line:='"'+snobolCompiler+'"'+ ' "'+fileNameWithPath+'"' +' ';

end else begin   //use comline
   cline:=replacein('MYFILE',' "'+fileNameWithPath+'"', commandlineargs);
   line:='"'+snobolCompiler+ '" '+ cline;
end;
writeln(batfile,line);
writeln(batfile, 'pause');
closeFile(batFile);
SetCurrentDir(userFileFolder);
openDocument(userfilefolder+'\docomp.bat'); //run it
end;

//-----------------------------------------------------------------------------

procedure TTMainForm.runButtonClick(Sender: TObject);
begin
//run   prog
if fileNameWithPath ='' then
   showMessage('No program !  (not saved?)')
else if snobolCompiler ='' then
   showmessage('No Snobol system has been set up - please see:  Tools | Configure.')

else if fileNamewithPath<>'' then
  interpretApplic; //was compileapplic
end;
//-----------------------------------------------------------------------------


//  INDENTER SECTION---------------------------------------------------------

procedure calcNextIndent(line: string;  var current: integer; var nextIndent: integer);
//call indent for following one, based on current level
begin
nextIndent:=current;
if pos( '/WHILE', line) <> 0 then begin
    nextindent:=current+1;
    whileCount:=whileCount+1;
end;

if pos( '/WEND', line) <> 0 then begin
    current:=current-1;
    nextindent:=current;
    wendCount:=wendCount+1;

end else if pos( '/IF', line) <> 0 then begin  //L then R
    nextindent:=current+1;
    ifCount:=ifCount+1;

end else if pos( '/ELSE', line) <> 0 then begin //optional, hard to count
    current:=current-1;
    nextindent:=current+1;

end else if pos( '/FI', line) <> 0 then begin
    current:=current-1;
    nextindent:=current;
    fiCount:=fiCount+1;
 end
end;

//-----------------------------------------------------------------------------

procedure gotLabelCommentContin(var line: string; current:integer);
//label must stay at left, try to do right part, comment,continue are similar, may be no space in line
var
firstCh, statement,thelabel, commentText:string;
  posSpace: integer;
begin
firstch:=copy(line,1,1);
if  (firstch='*') or (firstch='+')or (firstch='.') then begin   //comment, contin ,split
   commentText:=  trim(copy(line, 2, length(line)-1));
   line:='*'+' '+stringofChar(' ', current*STEP - 2)+commentText;

end else begin //label
    posSpace:=pos(' ', line);
    if posSpace=0 then
        exit //only a label

    else Begin //split line in 2
        statement:=  trim(copy(line, posSpace+1, length(line)-posSpace));
        thelabel:=trim((copy(line, 1 , posSpace-1)));
        //calc gap, based on label length and current indent, minimum is 1 space
        line:=thelabel+' '+stringOfChar(' ', (current*STEP)-posspace)+statement; //return it
   end;
end;
end;


//----------------------------------------------------------------------------
procedure TTMainForm.doPrettyPrint;
var
line, userFileFolder: string;
current, nextIndent, n:integer;
Code: TstringList;   //a new one, in case amything goes wrong

begin
DoSaveFile;
userFileFolder:=ExtractFileDir(fileNameWithPath);
EditWin.Lines.SaveToFile(fileNameWithPath);
EditWin.modified:=true;

EditWin.Lines.SaveToFile( userfileFolder+ '\backup-pretty-sno.txt');  //just in case
Code:=TStringList.Create;
Code.sorted:=false;
current:=1;    //how many  'tabs'

for n:=0 to   EditWin.lines.count-1 do begin   //copy lines
    code.add ( Editwin.lines[n]);
end;

ifCount:=0;fiCount:=0;
whileCount:=0; wendCount:=0;

nextIndent:=current;
for n:= 0 to code.count-1 do begin
    line:= code[n];
    current:=nextIndent;

    if copy(line, 1,1 )<>' ' then begin
        calcNextIndent(line, current, nextIndent);
        gotLabelCommentContin(line, current);
    end else begin
       calcNextIndent(line, current, nextIndent);
       line:=stringOfChar(' ', current*STEP)+trim(line);
    end;  //if
    code[n]:=line;
end;// for
 //re-show
for n:= 0 to code.count-1 do begin
     editwin.lines[n]:=code[n];
end;
//unmatched?
if whileCount <> wendCount then
    showmessage('Warning - /WHILE - /WEND unmatched, '+ inttostr(whilecount) +
    '  and  '+inttostr(wendcount) + ' occurrences.');

if ifcount<>fiCount then
    showmessage('Warning - /IF - /FI unmatched, '+ inttostr(ifcount) +
    '  and '+inttostr(ficount)+ ' occurrences.');
end;
//     END INDENTER SECTION ----------------------------------------------------

//------------------------------------------------------------------------------

//   CROSSREF SECTION ----------------------------------------------------------
procedure NextItem(s: string; var p: integer;var line: integer;  var item:string);     //used by crossref
var
onechar:char;
var ended:boolean;
ch:string;
begin
item:='';

//begin get a non-separator
ended:=false;

while ( (not ended) and not(s[p] in [  'a'..'z', 'A'..'Z', '0'..'9'] ))    do begin
     if s[p]=CR then
        line:=line+1;
//
     p:=p+1;
     if p> length(s) then
         ended:=true;
end;

if ended then
    ch:='END'
else
    ch:= s[p];

p:=p+1;
//----end getnonsep------

if ch = 'END' then
     item:=''       // done
else begin
     item:= ch;  // first one of new word
     ch:=s[p];
     oneChar:=s[p];
     while (oneChar in  ['@', 'a'..'z', 'A'..'Z', '0'..'9', '_']  ) and (p<length(s)) do begin
          item:=item+oneChar;
          p:=p+1;
          oneChar:=s[p];

     end;// get 1 item

end;
end; //   end next item

//---------------------------------------------------------------------------

function TTMainForm.CrossRef:string;
var
 itemList, listWithNumbers:TStringList;
  line, p: integer;
s,item, tempOld,output, listing: string;
fullFilePath: string;
n, place:integer;
programCode:TStringList;

begin
programCode:=TStringList.Create;
ProgramCode.sorted:=false;

programCode.LoadFromFile(fileNameWithPath);

//make line-numered listing for the report file
for n:=0 to programCode.count-1 do begin   //code listing, numbered
      listing:=listing + intToStr(n+1)+ '  ' + programCode.Strings[n] +CRLF;
 end;
//do the cross ref
s:=programCode.text+' ';    //all into s

itemList:=TStringList.Create;
itemList.casesensitive:=true;
listWithnumbers:=TStringList.Create;
itemList.sorted:=true;
listWithNumbers.sorted:=true;
line:=1;
p:=1;
NextItem(s, p, line, item);    //updates p, line num, item

while (item<>'')  do begin
        if itemList.find(item, place)=false then begin
            itemList.add(item);
            listWithNumbers.add (item+ '    '+ inttostr(line) + ' ');
            end
        else begin  // there already
            tempOld:=listWithNumbers.strings[place];
            listWithNumbers.sorted:=false;
            listWithnumbers.strings[place]:=
                        tempOld+ ', ' + inttostr(line);

            listWithNumbers.sorted:=true;
        end;//if

        NextItem(s, p, line, item);
end;//while items to process

for n:=0 to listWithNumbers.count -1 do
     output:=output + listWithnumbers.Strings[n] +CRLF;

CrossRef:=listing +CRLF + '------  Listing ------'+ CRLF + output;     //poor names todo
itemList.free;
listWithNumbers.free;

ProgramCode.free;   //garbage
//yes end------------
end;
//---------------------------------------------------------------------------------


procedure TTMainForm.XrefSpellButtonClick(Sender: TObject);      //snobol
var
userfileFolder: string;
begin
If  fileNameWithPath <>'' then begin   //work to do
    userFileFolder:=ExtractFileDir(fileNameWithPath);
    EditWin.Lines.SaveToFile( fileNameWithPath);
    EditWin.Modified := False;

    assignFile(outfile, userFileFolder+ '\crossref-result.txt');   //users folder
    rewrite(outfile);
    writeln(outfile, 'Cross-reference of: '+fileNameWithPath);
    writeln(outfile,  '');
    writeln(outfile, crossref );;
    closeFile(outfile);
   openDocument( userFileFolder+ '\crossref-result.txt');
end;  //if
end;

//   END CROSSREF SECTION ------------------------------------------------------

//---------------------------------------------------------------------------

procedure TTMainForm.pasteMenuItemClick(Sender: TObject);
begin
       EditWin.PasteFromClipboard;
end;

 //-----------------------------------------------------------------------------

procedure TTMainForm.replaceMenuItemClick(Sender: TObject);
begin
    FPos:=0;
    replaceDialog1.execute;
end;

//---------------------------------------------------------------------------

procedure TTMainForm.copyMenuItemClick(Sender: TObject);
begin
 EditWin.CopyToClipboard;
end;
//---------------------------------------------------------------------------
      mm
 procedure TTMainForm.undoMenuItemClick(Sender: TObject);
begin
    editWin.undo;
end;
//----------------------------------------------------------------------------

procedure TTMainForm.cutMenuItemClick(Sender: TObject);
begin
EditWin.CutToClipboard;
end;
//--------------------------------------------------------------------------

procedure TTMainForm.editWinChange(Sender: TObject);
begin
end;

//---------------------------------------------------------------------------
procedure TTMainForm.findMenuItemClick(Sender: TObject);
begin
FPos:=0;
findDialog1.execute;
end;

//----------------------------------------------------------------------------
procedure TTMainForm.exitMenuItemClick(Sender: TObject);
begin
  Close;
end;

//-----------------------------------------------------------------------------

procedure TTMainForm.helpOnRideMenuClick(Sender: TObject);
var s:string;
begin
if snobolCompiler <>'' then begin
  //  chdir(IDEdirectory);
    openDocument(IDEDirectory+'\'+'snobedhelp.txt');
end
else
    showMessage('Not configured yet - look atsnoedhelp.txt  with a text editor.');
end;


//-----------------------------------------------------------------------------
procedure TTMainForm.closeMenuClick(Sender: TObject);
begin
 Close;
end;
//------------------------------------------------------------------------------

procedure TTMainForm.ChooseRedInterpClick(Sender: TObject);
var
    intro:string;
begin
 intro:='When the following window appears, browse to a snobol?.exe  or  spitbol?.exe file'+CRLF+CRLF+
      '  and click "open".  '+CRLF + CRLF+
        'Do you wish to continue?';

if MessageDlg(intro, mtConfirmation,[mbYes,mbNo],0)=mrYes then begin
       OpenDialogExe.Filename:='';
       OpenDialogExe.title:='Selecting Snobol compiler  .exe file';
       if OpenDialogExe.Execute then  begin

           snobolCompiler:=openDialogExe.FileName;
            ShowMessage('This program will now make use of this Snobol system: '+CRLF+CRLF+     //full file name
                             openDialogExe.filename + CRLF+CRLF+ '   -  configuration completed.'+
                            CRLF+ 'Re-run this editor for the change to take effect.'+CRLF+CRLF+
                            '  ');

            chDir(IDEDirectory);
            assignFile(outFile,'snobol.ini');
            rewrite(outFile);
            writeln(outFile,   snobolCompiler);
            closeFile(outFile);

       end;
end; {user cancelled config}

end;
//----------------------------------------------------------------------------

procedure TTMainForm.FragmentsButtonClick(Sender: TObject);
 begin
 //showMessage('not available yet.');
 chdir(IDEdirectory);
 openDocument('snobedfragments.txt');


 end;
//--------------------------------------------------------------------------


procedure TTMainForm.MenuItem1Click(Sender: TObject);
begin

end;

procedure TTMainForm.MenuItem5Click(Sender: TObject);
begin
showmessage('Snobed -   pre-release version:    '+VERSION);
end;

//-----------------------------------------------------------------------------
procedure TTMainForm.newUnitppClick(Sender: TObject); //run art pp - new june 2021
begin
doPrettyPrint;
end;
//-------------------------------------------------------------------
procedure TTMainForm.PairSplitterSide1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
end;
//-------------------------------------------------------------------------
procedure TTMainForm.PairSplitterSide2MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
end;


//-----------------------------------------------------------------------------
procedure TTMainForm.newFileClickClick(Sender: TObject);
begin
if  OKtoCloseCurrentDoc then
     // if OpenDialog.Execute then

            begin
             SetFileName('' );
             EditWin.SetFocus;
             EditWin.Modified := True;      // new code
             editWin.text:='    OUTPUT = ''Hello World!'''+CRLF+'END'+CRLF;
            end;
end;

//--------------------------------------------------------------------------
procedure TTMainForm.redConsoleClick(Sender: TObject);
var line: string;
begin
Assignfile(batFile,'docomp.bat');
rewrite(batFile);
line:='"'+snobolCompiler+'" ' + '--no-color';
writeln(batfile,line);
closeFile(batFile);
openDocument('docomp.bat');    //was execcommand
end;
//-----------------------------------------------------------------------------

procedure TTMainForm.RunExeButtonClick(Sender: TObject);
   var line, exeName:string;
begin
exeName:=replacein('.red', '.exe', fileNameWithPath);

if snobolCompiler='' then
      showMessage('snobol system is unconfigured - use Tools menu.')
 else  if fileNameWithPath ='' then
     showMessage('No snobol program !   (not saved?)')
else if EditWin.modified=true then     //changed, not saved  -yet
     showmessage ('You  must compile your program. ')// compiledOK?  No class Load?  win empty...??
else  if not FileExists(exeName) then
    showMessage('File not found:  ' + exeName)
else               //nb if changed, saved, but not compiled, it runs earlier vn  todo note

begin       //run exe
ErrorListBox.Clear;
EditWin.Lines.SaveToFile(fileNameWithPath);
EditWin.modified:=false;

Assignfile(batFile,'comperrs.txt');

rewrite(batFile);
writeln(batfile, 'empty');
closeFile(batFile);

Assignfile(batFile,'dorunexe.bat');
rewrite(batFile);

line:= '"'+exeName+'"'  +' '+ commandLineArgs;
writeln(batfile,line);             //in same folder as Ride
writeln(batfile,'pause');           //keep screen

closeFile(batFile);
openDocument('dorunexe.bat');
end;
end;

//-----------------------------------------------------------------------------

procedure TTMainForm.ShowChosenInterpClick(Sender: TObject);
begin
if snobolCompiler='' then
     showmessage('This program has not been informed about an snobol System.')
else
    showmessage('This program will use this snobol system:'+CRLF+
         '          '+  snobolCompiler + CRLF+
         ' ');    //'in the same folder as Ride.' );
end;
//-----------------------------------------------------------------------------

procedure TTMainForm.ClearCLAClick(Sender: TObject);     //todo move up code
begin  //clear com line args
commandLineArgs:='';
end;



//---------------------------------------------------------------------------------
procedure TTMainForm.biggerTextmenuItemClick(Sender: TObject);
const
fontMax=22;
begin
if EditWin.font.Size < fontMax then begin
    EditWin.font.Size :=    EditWin.font.Size+1;
    EditWin.SetFocus;
end;
end;
//-----------------------------------------------------------------------------

procedure TTMainForm.bracketsButtonClick(Sender: TObject);     //todo del?

var line, errLine, allMessage, resultFile, bracketsBat, bracketsExe: string;
begin
resultFile:='.\brackets-result.txt'; //const
bracketsBat:='.\dorun-brackets.bat';
bracketsExe:='.\artbrackets.exe';
chdir(IDEdirectory);
if not fileExists(bracketsExe) then
    showMessage('Error: missing brackets.exe file!')
 else
     If  FileNameWithPath <>'' then begin   //work to do
          EditWin.Lines.SaveToFile( FileNameWithPath);
          EditWin.Modified := False;

          Assignfile(batFile, bracketsBat);
           rewrite(batFile);
           line:=qu+bracketsExe+qu +'  '  + qu+FileNameWithPath+qu;
           writeln(batfile,line);
      //     writeln(batfile, qu+resultFile+qu);   //open txt file in an editor
           closeFile(batFile);
           opendocument(bracketsBat);

          sleep(400);        //seems ok

        Assignfile(ppStatus, resultFile);     //todo poor file name
        reset(ppStatus);
        errline:= '';          //not err  infact
        allMessage:='';
        while not eof(ppStatus ) do begin
            readln(ppStatus, errline);
            allMessage:=allMessage+errline
        end;
        closeFile(ppStatus);

          showMessage(allMessage);
        end;

   //  end;
end;


//-----------------------------------------------------------------------------

procedure TTMainForm.smallerTextMenuItemClick(Sender: TObject);
const
 fontMin=8;
begin
if EditWin.font.Size > fontMin then begin
    EditWin.font.Size :=    EditWin.font.Size-1;
    EditWin.SetFocus;
end;
end;
//-----------------------------------------------------------------------------


//-------------------------------------------------------------------------------

procedure TTMainForm.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin
   if OKtoCloseCurrentDoc then
      CanClose := true
   else
      CanClose := false;
end;

//-----------------------------------------------------------------------------

// --- FORM Create and Close , init
procedure TTMainForm.FormCreate(Sender: TObject);
var
   iniName:string;
begin
ClearEditWin;
EditWin.HideSelection := false; // show selection when EditWin loses focus
//   ShowCursorPos;
snobolCompiler:='';
IDEDirectory:=GetCurrentDir;      // where ved was run from
fileNameWithPath:='';
commandLineArgs:='';

//get ini file if it exists .  line 1 is snobol sys, li
// line 2 an initial use dir path //used?
iniName:='snobol.ini';
chDir(IDEDirectory);       //always in IDE dir
if fileExists(iniName) then begin
    AssignFile(inFile, iniName);
    reset(infile);
    readln(inFile,snobolCompiler);
    snobolCompiler:=trim(snobolCompiler);
    readln(infile,initialUserDir);
    initialUserDir:=trim(initialUserDir);
    openDialog.initialDir:= initialUserDir;
    saveDialog.initialDir:=initialUserDir;
    closeFile(infile);
    end;

end;

//-------------------------------------------------------------------------------
end.

